SUBROUTINE bc_ls_dc(Nx, Ny, nz,DZ, U, V, ST, mu_l, PHI, phi_x, phi_y, angac, angrc)
IMPLICIT NONE
INTEGER,PARAMETER :: DP = SELECTED_REAL_KIND(p=15)
REAL(KIND=DP),PARAMETER                  :: PI = 3.141592653589793_DP

REAL(KIND=DP), INTENT(IN) :: U(:,:,:), V(:,:,:), DZ, ST, phi_x(:,:,:), phi_y(:,:,:), angrc, angac, mu_l
REAL(KIND=DP), INTENT(INOUT) :: PHI(:,:,:)
real(kind=dp) :: aaa
INTEGER, INTENT(IN) :: Nx, Ny, nz
integer :: i, j, k

do i = 2, nx-1
do j = 2, ny-1
	
	if( (v(i,j,1)*phi_x(i,j,1)+u(i,j,1)*phi_y(i,j,1)) < 0.0_dp )then
		aaa = angrc
	elseif( (v(i,j,1)*phi_x(i,j,1)+u(i,j,1)*phi_y(i,j,1)) > 0.0_dp )then
		aaa = angac
	end if
	
	if( phi_x(i,j,1) >= phi_y(i,j,1) )then
	if( phi(i,j,1)*phi(i+1,j,1)< 0.0_dp )then
	if( phi(i,j,1)>0.0_dp) then
		phi(i,j,1) = phi(i,j,2) + dz*cos( fh( mu_l*sqrt( v(i,j,1)**2+u(i,j,1)**2)/st + ifh(aaa) ))
	elseif( phi(i,j,1)<0.0_dp) then
	if( (v(i+1,j,1)*phi_x(i+1,j,1)+u(i+1,j,1)*phi_y(i+1,j,1)) < 0.0_dp )then
		aaa = angrc
	elseif( (v(i+1,j,1)*phi_x(i+1,j,1)+u(i+1,j,1)*phi_y(i+1,j,1)) > 0.0_dp )then
		aaa = angac
	end if
		phi(i+1,j,1) = phi(i+1,j,2) + dz* cos(fh( mu_l*sqrt( v(i+1,j,1)**2+u(i+1,j,1)**2)/st + ifh(aaa) ))
	end if
	end if
	
	elseif( phi_x(i,j,1) < phi_y(i,j,1) )then
		if( phi(i,j,1)*phi(i,j+1,1) < 0.0_dp )then
		if( phi(i,j,1)> 0.0_dp )then
		  phi(i,j,1) = phi(i,j,2) + dz*cos(fh( mu_l*sqrt( v(i,j,1)**2+u(i,j,1)**2)/st + ifh(aaa) ))
		elseif( phi(i,j,1)<0.0_Dp)then
		if( (v(i,j+1,1)*phi_x(i,j+1,1)+u(i,j+1,1)*phi_y(i,j+1,1)) < 0.0_dp )then
		   aaa = angrc
	  elseif( (v(i,j+1,1)*phi_x(i,j+1,1)+u(i,j+1,1)*phi_y(i,j+1,1)) > 0.0_dp )then
		   aaa = angac
	  end if
			phi(i,j+1,1) = phi(i,j+1,2) + dz*cos(fh( mu_l*sqrt( v(i,j+1,1)**2+u(i,j+1,1)**2)/st + ifh(aaa) ))			 
		end if
		end if
		end if

phi(i,j,nz) = u(i,j,nz-1)

end do
end do

do j = 2, ny-1
do k = 2, nz-1
	
	phi(1,j,k) = phi(2,j,k)
	phi(nx,j,k) = phi(nx-1,j,k)
	
end do
end do

do k = 2, nz-1
do i = 2, nx-1
	
	phi(i,1,k) = phi(i,2,k)
	phi(i,ny,k) = phi(i,ny-1,k)
	
end do
end do	
		
END SUBROUTINE

REAL FUNCTION fH(X)
INTEGER,PARAMETER :: DP = SELECTED_REAL_KIND(p=15)
REAL(KIND=DP) :: X

FH = ACOS( 1.0_DP - 2.0_DP*TANH( 5.16_DP*( X / ( 1.0_DP + 1.31_DP*X**(0.99_DP)))**(0.706_DP))  )

end function fh

real function ifh(x)
INTEGER,PARAMETER :: DP = SELECTED_REAL_KIND(p=15)
real(kind=dp) :: x, a

ifh = (1.0_dp/10.32_dp * log( (1.0_dp+(1.0_dp-cos(x)))/(1.0_dp-(1.0_dp-cos(x)))))**( 1.0_dp/0.706_dp)/( 1.0_dp - 1.31_dp*(1.0_dp/10.32_dp * log( (1.0_dp+(1.0_dp-cos(x)))/(1.0_dp-(1.0_dp-cos(x)))))**( 1.0_dp/0.706_dp))


end function  ifh

